/*
 * Created on 21.04.2005 by Daniel Hohenberger.
 */
package de.hd42.itemlister;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;

public class MakeFrame extends JFrame {

	private static final long serialVersionUID = 3257853177247511857L;
	
	private ItemLister il;
	private JEditorPane market;
	
	public MakeFrame(ItemLister il) throws HeadlessException {
		super(Strings.getString("ItemLister.Generate.Title"));
		this.il = il;
		JPanel makePanel = new JPanel();
		makePanel.setLayout(new BoxLayout(makePanel, BoxLayout.Y_AXIS));
		
		market = new JEditorPane("text/plain", "Der Marktstand");
		JScrollPane scroll = new JScrollPane(market);
		scroll.setPreferredSize(new Dimension(480, 640));
		makePanel.add(scroll);
		
		JComboBox sortList = new JComboBox(new String[]{ItemLister.PCN, ItemLister.CPN,
				ItemLister.PN, ItemLister.CN});
		sortList.setSelectedIndex(0);
		sortList.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ItemLister.setSorting((String)((JComboBox)e.getSource()).getSelectedItem());
			}
		});
		sortList.setAlignmentX(JComponent.LEFT_ALIGNMENT);
		makePanel.add(sortList);

		JCheckBox catsBox = new JCheckBox(Strings.getString("ItemLister.Generate.UseCats")); //$NON-NLS-1$
		catsBox.setSelected(ItemLister.isUseCats());
		catsBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			    Object source = e.getItemSelectable();
				ItemLister.setUseCats(((JCheckBox)source).isSelected());
			}
		});
		catsBox.setAlignmentX(JComponent.LEFT_ALIGNMENT);
		makePanel.add(catsBox);
		

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.setAlignmentX(JComponent.LEFT_ALIGNMENT);
		
		JButton doit = new JButton(Strings.getString("ItemLister.Generate.MakeButton")); //$NON-NLS-1$
		doit.setActionCommand(Strings.getString("ItemLister.Generate.MakeCommand")); //$NON-NLS-1$
		doit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(Strings
						.getString("ItemLister.Generate.MakeCommand").equals(e.getActionCommand())){ //$NON-NLS-1$

					MakeFrame.this.market.setText(MakeFrame.this.il.createOutput());
					MakeFrame.this.repaint();
				}
			}
		});
		buttonPanel.add(doit);
		
		JButton save = new JButton(Strings.getString("ItemLister.Generate.SaveButton")); //$NON-NLS-1$
		save.setActionCommand(Strings.getString("ItemLister.Generate.SaveCommand")); //$NON-NLS-1$
		save.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(Strings
						.getString("ItemLister.Generate.SaveCommand").equals(e.getActionCommand())){ //$NON-NLS-1$
					File outputfile = ItemLister.chooseFile(Strings
							.getString("ItemLister.Generate.SaveButton"), MakeFrame.this); //$NON-NLS-1$
					MakeFrame.this.il.saveOutput(outputfile, MakeFrame.this.market.getText());
				}
			}
		});
		buttonPanel.add(save);

		makePanel.add(buttonPanel);
		
		this.getContentPane().add(makePanel);
		this.pack();
		this.validate();
		this.setVisible(true);
	}
}
